/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//
//	LO共通 環境ファイルロードクラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.lo;

import java.util.*;
import java.io.*;
import jp.co.ntt.lms.xmo.util.DebugLog;
import jp.co.ntt.lms.xmo.Environment;

/**
 * LO共通 環境ファイルロードクラスです。<BR>
 * @author T.Nijou
 * @version 0.0.0.1 2004/01/08
 */
public class LoEnvironment
{

	private static final String mstrFileName = "/conf/Lo.ini";

	/** プロパティファイルを保持します */
	private Properties mobjLoProperty = null;

	/** 自身を保持します */
	private static LoEnvironment mobjLoEnv = null;

	/** Environmentクラスを保持します */
	protected Environment mobjEnv = null;

	// プロパティ定義
	/** WBT学習開始パラメータ */
	public static final String XCAL_QUR = "xcal_qur";
	/** WBT学習開始URL */
	public static final String XCAL_LEARN_URL = "xcal_learn_url";

	/** 学習開始サーブレットURL */
	public static final String START_SERVLET_URL = "start_servlet_url";
	/** 学習終了サーブレットURL */
	public static final String END_SERVLET_URL = "end_servlet_url";
	/** 学習サーブレットパラメータ */
	public static final String LEARN_PARAM = "learn_param";
	/** 評価ウィンドウオープンフラグ */
	public static final String ESTIMATION   = "ESTIMATION";

	/** 学習画面のウィンドウサイズ(縦) */
	public static final String WIN_HEIGHT   = "w_height";
	/** 学習画面のウィンドウサイズ(横) */
	public static final String WIN_WIDTH   = "w_width";

	/**
	 * コンストラクタです
	 * @exception LoEnvironment
	 */
	protected LoEnvironment()
		throws LOException
	{
		try {
			init();
		}
		catch( Exception e ) {
			throw new LOException(e.getMessage());
		}
	}

	/**
	 * インスタンスを取得します
	 */
	public static LoEnvironment getInstance()
		throws LOException
	{
		try {
			if( mobjLoEnv == null ) {
				mobjLoEnv = new LoEnvironment();
			}
		}
		catch( Exception e ) {
			throw new LOException(e.getMessage());
		}
		return mobjLoEnv;
	}

	/**
	 * 環境ファイルを読み込みます
	 */
	public void init() throws Exception {
		// クラス単位の排他処理を行う。
		synchronized( this.getClass() ) {
			//	環境情報の初期化が行われていない時のみ
			//	環境ファイルを読み込む
			if( mobjLoProperty == null ) {
				//mobjLoProperty = loadProperty(mstrFileName);
				mobjEnv = new Environment();
			}
		}
	}

	/**
	 * キーを元にプロパティ値を取得します
	 * @param strPropertyName
	 */
	public String getProperty( String strPropertyName )
		throws LOException
	{
		return getProperty( strPropertyName, mobjLoProperty );
	}

	/**
	 * キーを元にプロパティ値を取得します
	 * @param strPropertyName キー
	 * @param objProperty 親あるいは子供のプロパティ
	 */
	public String getProperty( String strPropertyName, Properties objProperty )
		throws LOException
	{
		try {
			if( objProperty == null ){
				return null;
			}

			String strValue;
			strValue = objProperty.getProperty( strPropertyName );
			if( strValue == null ) {
				String errMessage = "環境エラー:" + strPropertyName;
				LOException e = new LOException( errMessage );
				// ログ出力
				// DebugLogは相互参照になるため、標準出力に出力。
				e.printStackTrace();
				throw e;
			}

			return strValue;
		}
		catch( Exception e ) {
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException(e.getMessage());
		}
	}

	protected Properties loadProperty(String strIniFileName) throws LOException {

		Properties objProperty = null;

		try {
			//	環境ファイルオブジェクトの取得
			InputStream objFile = this.getClass().getResourceAsStream(strIniFileName );
			if( objFile != null ) {
				objProperty = new Properties();
				try{
					objProperty.load(objFile);
				}
				catch( IOException Ex ){
					throw Ex;
				}
				finally {
					//	環境ファイルをクローズする
					try {objFile.close();} catch( Exception e ) {}
				}
			}
			else {
				throw new LOException( "ファイルアクセスエラー：" + strIniFileName);
			}
		}
		catch( LOException le ) {
			DebugLog.write( this.getClass(), le, DebugLog.HIGHT );
			throw le;
		}
		catch( Exception e ) {
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException(e.getMessage());
		}

		return objProperty;
	}

	/**
	 * WBT学習開始URLパラメータを取得します
	 */
	public String getXcalQUR()
		throws LOException
	{
		return getProperty( XCAL_QUR );
	}

	/**
	 * 学習サーブレットのURLを取得します
	 * @param htParam マクロ展開時のパラメータ設定です
	 */
	public String getStartLearnServletURL( Hashtable htParam )
		throws LOException
	{
		// 学習サーブレットパラメータを取得します
		String strLearnParam = getLearnParam();

		// マクロ展開
		strLearnParam = expand( strLearnParam, htParam );

		// 学習開始URLを取得します
		String strLearnURL = getStartLearnServletURL() + strLearnParam;


		return strLearnURL;
	}

	/**
	 * 学習開始サーブレットのURLを取得します
	 */
	public String getStartLearnServletURL()
		throws LOException
	{
		try {
			String strURL = getProperty( START_SERVLET_URL );
			Hashtable htbMacro = new Hashtable();
			htbMacro.put( mobjEnv.SYSTEM_URL, mobjEnv.getSystemURL() );
			strURL = expand( strURL, htbMacro );
			return strURL;
		}
		catch( Exception e ) {
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException(e.getMessage());
		}
	}

	/**
	 * 学習サーブレットのURLを取得します
	 * @param htParam マクロ展開時のパラメータ設定です
	 */
	public String getEndLearnServletURL( Hashtable htParam )
		throws LOException
	{
		// 学習サーブレットパラメータを取得します
		String strLearnParam = getLearnParam();

		// マクロ展開
		strLearnParam = expand( strLearnParam, htParam );

		// 学習開始URLを取得します
		String strLearnURL = getEndLearnServletURL() + strLearnParam;

		return strLearnURL;
	}

	/**
	 * 学習終了サーブレットのURLを取得します
	 */
	public String getEndLearnServletURL()
		throws LOException
	{
		try {
			String strURL = getProperty( END_SERVLET_URL );
			Hashtable htbMacro = new Hashtable();
			htbMacro.put( mobjEnv.SYSTEM_URL, mobjEnv.getSystemURL() );
			strURL = expand( strURL, htbMacro );
			return strURL;
		}
		catch( Exception e ) {
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException(e.getMessage());
		}
	}

	/**
	 * 学習サーブレットパラメータを取得します
	 */
	public String getLearnParam()
		throws LOException
	{
		Properties prop = getOriginalLoProperty();
		return getProperty( LEARN_PARAM, prop );
	}

	/**
	 * 環境ファイルを取得します。
	 * サブクラスでオーバライドしている場合、
	 * サブクラスで処理を実施します。
	 * 
	 * @return 環境ファイル情報
	 */
	protected Properties getOriginalLoProperty() {
		return mobjLoProperty;
	}

	/**
	 * 評価ウィンドウオープンフラグを取得します
	 *
	 * @return String 評価ウィンドウオープンフラグ
	 */
	public String getOption()
		throws LOException
	{
		return getProperty(ESTIMATION);
	}

	/**
	 * 文字列をマクロ展開します<BR>
	 * '$'で囲まれた文字列を取得し、引数で渡されたHashtableから
	 * 取得した文字列をキーにして、値を取得し、入れ替えて返します。
	 * @param strBase 変換前
	 * @param htbTable マクロ情報
	 * @return String 変換後文字列
	 */
	protected String expand(String strBase , Hashtable htbTable ) {
		// 返還前文字列をchar配列に変換します
		char[] chrBase = strBase.toCharArray();

		// 変換後の文字列を格納します
		StringBuffer sbBase = new StringBuffer();
		// '$'で囲まれてた文字列を格納します
		StringBuffer sbMacro = new StringBuffer();
		// マクロ文字列読み取り中か、普通の文字列読み取り中かを判断する
		boolean blMacro = false;
		// charの配列文ループします
		for( int i = 0; i < chrBase.length; i++ ) {
			// '$'の部分はマクロ文字列として格納します
			if( chrBase[i] == '$' ) {
				if( blMacro ) {
					blMacro = false;
					// マクロ文字列をキーにして、値を入れる
					String strMacro = (String)htbTable.get( sbMacro.toString() );
					// 取得した文字列がnull以外なら、設定
					if( strMacro != null ) {
						sbBase.append( (String)htbTable.get( sbMacro.toString() ) );
					}
					// マクロ文字列を初期化します
					sbMacro = new StringBuffer();
				}
				else {
					blMacro = true;
				}
				continue;
			}

			// マクロ読み取り中の場合
			if( blMacro ) {
				sbMacro.append( chrBase[i] );
			}
			// 普通の文字列読み取り中
			else {
				sbBase.append( chrBase[i] );
			}
		}
		return sbBase.toString();
	}
}
